; STACK00.AU3 - Speicherverwaltung mitttels Stack
; Lutz Mller, FH Kln Campus Gummersbach
#include-once
#include <Array.au3>

global $stack_pnt = 1
global $stack_max = 5
global $stack_0 = 0 ; 0 = Hilfsstack aus, 1 = Hilfsstack ein
dim $stack_data_0[1] ; Hilfsstack nur fr interne Operationen!!! - Diesen Stack bitte NICHT benutzen
dim $stack_data_1[1]
dim $stack_data_2[1]
dim $stack_data_3[1]
dim $stack_data_4[1]
dim $stack_data_5[1]

; Stack init
func inistack()
   select
      case $stack_pnt = 1
         $stack_data_0[0] = 'EOS' ; init Hilfsstack
         $stack_data_1[0] = 'EOS'
      case $stack_pnt = 2
         $stack_data_2[0] = 'EOS'
      case $stack_pnt = 3
         $stack_data_3[0] = 'EOS'
      case $stack_pnt = 4
         $stack_data_4[0] = 'EOS'
      case $stack_pnt = 5
         $stack_data_5[0] = 'EOS'
      case else
         msgbox(0,"Fehler: "&@ScriptName,"inistack(): Maximale Anzahl der Stacks erreicht")
         exit
   endselect
   $stack_pnt = $stack_pnt + 1
   return $stack_pnt - 1
endfunc

; Stackstatus 1 = Im Stack sind noch Elemente - 0 = Stack ist leer
func eos($n)
   if $n < 0 or $n > $stack_max then
      msgbox(0,"Fehler: "&@ScriptName,"eos("&$n&"): Den Stack gibt's nicht")
      exit
   endif
   select
      case $n = 0 and $stack_0
         if ubound($stack_data_0) > 1 then
            return 1
         else
            return 0
         endif
      case $n = 1
         if ubound($stack_data_1) > 1 then
            return 1
         else
            return 0
         endif
      case $n = 2
         if ubound($stack_data_2) > 1 then
            return 1
         else
            return 0
         endif
      case $n = 3
         if ubound($stack_data_3) > 1 then
            return 1
         else
            return 0
         endif
      case $n = 4
         if ubound($stack_data_4) > 1 then
            return 1
         else
            return 0
         endif
      case $n = 5
         if ubound($stack_data_5) > 1 then
            return 1
         else
            return 0
         endif
   endselect
endfunc

; legt $var auf stack $n
func push($n,$var)
   if $n < 0 or $n > $stack_max then
      msgbox(0,"Fehler: "&@ScriptName,"push("&$n&",$var): Den Stack gibt's nicht")
      exit
   endif
   select
      case $n = 0 and $stack_0
         _ArrayAdd($stack_data_0,$var)
      case $n = 1
         _ArrayAdd($stack_data_1,$var)
      case $n = 2
         _ArrayAdd($stack_data_2,$var)
      case $n = 3
         _ArrayAdd($stack_data_3,$var)
      case $n = 4
         _ArrayAdd($stack_data_4,$var)
      case $n = 5
         _ArrayAdd($stack_data_5,$var)
   endselect
endfunc

; holt das letzte eingegebene Element vom stack $n (LIFO - Last In First Out)
func pop($n)
   if $n < 0 or $n > $stack_max then
      msgbox(0,"Fehler: "&@ScriptName,"pop("&$n&"): Den Stack gibt's nicht")
      exit
   endif
   select
      case $n = 0 and $stack_0
         if ubound($stack_data_0) > 1 then return _ArrayPop ($stack_data_0)
      case $n = 1
         if ubound($stack_data_1) > 1 then return _ArrayPop ($stack_data_1)
      case $n = 2
         if ubound($stack_data_2) > 1 then return _ArrayPop ($stack_data_2)
      case $n = 3
         if ubound($stack_data_3) > 1 then return _ArrayPop ($stack_data_3)
      case $n = 4
         if ubound($stack_data_4) > 1 then return _ArrayPop ($stack_data_4)
      case $n = 5
         if ubound($stack_data_5) > 1 then return _ArrayPop ($stack_data_5)
   endselect
endfunc

; kopiert m-te Element auf den Stack n$: (... xm ...x1) -> (...xm ...x1 xm)
func pick($n,$m)
   local $d1,$l
   if $n < 0 or $n > $stack_max then
      msgbox(0,"Fehler: "&@ScriptName,"pick("&$n&"): Den Stack gibt's nicht")
      exit
   endif
   select
      case $n = 0 and $stack_0
         $l = ubound($stack_data_0)
         if ($m >= $l) or ($m < 1) then return
         $d1 = $stack_data_0[$l - $m]
         push($n,$d1)
      case $n = 1
         $l = ubound($stack_data_1)
         if ($m >= $l) or ($m < 1) then return
         $d1 = $stack_data_1[$l - $m]
         push($n,$d1)
      case $n = 2
         $l = ubound($stack_data_2)
         if ($m >= $l) or ($m < 1) then return
         $d1 = $stack_data_2[$l - $m]
         push($n,$d1)
      case $n = 3
         $l = ubound($stack_data_3)
         if ($m >= $l) or ($m < 1) then return
         $d1 = $stack_data_3[$l - $m]
         push($n,$d1)
      case $n = 4
         $l = ubound($stack_data_4)
         if ($m >= $l) or ($m < 1) then return
         $d1 = $stack_data_4[$l - $m]
         push($n,$d1)
      case $n = 5
         $l = ubound($stack_data_5)
         if ($m >= $l) or ($m < 1) then return
         $d1 = $stack_data_5[$l - $m]
         push($n,$d1)
   endselect
endfunc

; verschiebt m-te Element AUF den Stack n$: (... xn xm-1 ...x1) -> (...xm-1 ...x1 xm)
func roll($n,$m)
   local $l
   if $n < 0 or $n > $stack_max then
      msgbox(0,"Fehler: "&@ScriptName,"roll("&$n&"): Den Stack gibt's nicht")
      exit
   endif
   select 
      case $n = 0 and $stack_0
         $l = ubound($stack_data_0) - $m
         pick($n,$m)
         _ArrayDelete($stack_data_0,$l)
      case $n = 1
         $l = ubound($stack_data_1) - $m
         pick($n,$m)
         _ArrayDelete($stack_data_1,$l)
      case $n = 2
         $l = ubound($stack_data_2) - $m
         pick($n,$m)
         _ArrayDelete($stack_data_2,$l)
      case $n = 3
         $l = ubound($stack_data_3) - $m
         pick($n,$m)
         _ArrayDelete($stack_data_3,$l)
      case $n = 4
         $l = ubound($stack_data_4) - $m
         pick($n,$m)
         _ArrayDelete($stack_data_4,$l)
      case $n = 5
         $l = ubound($stack_data_5) - $m
         pick($n,$m)
         _ArrayDelete($stack_data_5,$l)
   endselect
endfunc

; dupliziert das 1. Element von stack $n: (x1) -> (x1 x1)
func dup($n)
   if $n < 0 or $n > $stack_max then
      msgbox(0,"Fehler: "&@ScriptName,"dup("&$n&"): Den Stack gibt's nicht")
      exit
   endif
   pick($n,1)
endfunc

; kopiert das 2. Element von stack $n: (x2 x1) -> (x2 x1 x1)
func over($n)
   if $n < 0 or $n > $stack_max then
      msgbox(0,"Fehler: "&@ScriptName,"over("&$n&"): Den Stack gibt's nicht")
      exit
   endif
   pick($n,2)
endfunc

; tauscht das 1. Element mit dem 2. Element von stack $n: (x2 x1) -> (x1 x2)
func swap($n)
   local $d1, $d2
   if $n < 0 or $n > $stack_max then
      msgbox(0,"Fehler: "&@ScriptName,"swap("&$n&"): Den Stack gibt's nicht")
      exit
   endif
   roll($n,2)
endfunc

; tauscht das 1. Element mit dem 3. Element von stack $n: (x3 x2 x1) -> (x2 x1 x3)
func rot($n)
   local $d1, $d2, $d3
   if $n < 0 or $n > $stack_max then
      msgbox(0,"Fehler: "&@ScriptName,"rot("&$n&"): Den Stack gibt's nicht")
      exit
   endif
   roll($n,3)
endfunc

; entfernt das 1. Element von stack $n: (x1 ) -> ( )
func drop($n)
   if $n < 0 or $n > $stack_max then
      msgbox(0,"Fehler: "&@ScriptName,"drop("&$n&"): Den Stack gibt's nicht")
      exit
   endif
   pop($n)
endfunc

; zeigt die Anzahl der Elemente von stack $n
func stacklen($n)
   if $n < 0 or $n > $stack_max then
      msgbox(0,"Fehler: "&@ScriptName,"stell("&$n&"): Den Stack gibt's nicht")
      exit
   endif
   select
      case $n = 0 and $stack_0
         return ubound($stack_data_0) - 1
      case $n = 1
         return ubound($stack_data_1) - 1
      case $n = 2
         return ubound($stack_data_2) - 1
      case $n = 3
         return ubound($stack_data_3) - 1
      case $n = 4
         return ubound($stack_data_4) - 1
      case $n = 5
         return ubound($stack_data_5) - 1
   endselect
endfunc

; zeigt stack $n in einer msgbox - $c = Kommentar
func stack2box($n,$c)
   local $i, $s, $d
   $s = $c&chr(13)&chr(10)
   if $n < 0 or $n > $stack_max then
      msgbox(0,"Fehler: "&@ScriptName,"stack2box("&$n&"): Den Stack gibt's nicht")
      exit
   endif
   for $i = 1 to stacklen($n)
      pick($n,$i)
      $s = $s&"Ele_"&$i&" = "&pop($n)&chr(13)&chr(10)
   next
   msgbox(0,"Inhalt von Stack "&$n,$s)
endfunc

; verschiebt min(wenn $f=0) oder max(wenn $f=1) auf den Stack $n
func minimax($n,$f)
   local $a, $b, $d, $i, $z
   if $n < 0 or $n > $stack_max then
      msgbox(0,"Fehler: "&@ScriptName,"minimax("&$n&"): Den Stack gibt's nicht")
      exit
   endif
   $a = stacklen($n)
   if $a > 1 then
      dup($n)
      $d = pop($n)
      $z = 1
      for $i = 1 to $a
         pick($n,$i)
         $b = pop($n)
         if $f then
            if $b > $d then
               $d = $b
               $z = $i
            endif
         else
            if $b < $d then
               $d = $b
               $z = $i
            endif
         endif
      next
      roll($n,$z)
   else
      return
   endif
endfunc

; sortiert Stack $n, aufsteigend (wenn $f=0) oder absteigend (wenn $f=1)
func stacksort($n,$f)
   local $a,$i
   if $n < 0 or $n > $stack_max then
      msgbox(0,"Fehler: "&@ScriptName,"sortstack("&$n&"): Den Stack gibt's nicht")
      exit
   endif
   $a = stacklen($n)
   if $a < 2 then return ; hier gibt's nichts zu sortieren
   $stack_0 = 1
   for $i = 1 to $a
      minimax($n,$f)
      push(0,pop($n))
   next
   for $i = 1 to $a
      push($n,pop(0))
   next
   $stack_0 = 0
endfunc

; kehrt die Reihenfolge der Elemente von Stack $n um
func stackrevers($n)
   local $a,$i
   if $n < 0 or $n > $stack_max then
      msgbox(0,"Fehler: "&@ScriptName,"sortstack("&$n&"): Den Stack gibt's nicht")
      exit
   endif
   $a = stacklen($n)
   if $a < 2 then return ; hier gibt's nichts umzukehren
   $stack_0 = 1
   for $i = $a to 1 step -1
      roll($n,$i)
      push(0,pop($n))
   next
   for $i = 1 to $a
      push($n,pop(0))
   next
   $stack_0 = 0
endfunc